#Script by Lobster Man: AIM - LobsterMan246, Steam - Lobster_Man246
# www.f10community.com & www.newslobster.com

import es
import gamethread
import playerlib

#################CONFIGURATION START###########
#time in seconds before the respawn takes place
n = 15

#seconds after round_start that respawns are disabled, set this very high (ex: 9999) to never have respawns be disabled
t = 60

#number of times per round people may respawn
limit = 1
#################CONFIGURATION END#############

#steamid:respawn count
respawn_status = {}

#global to prevent people from invoking !respawn after a round_end but before the next round_start
respawn_enabled = 1

def load():
	
	if not es.exists('saycommand', '!respawn'):
		es.regsaycmd('!respawn', 'delayed_respawn/start_countdown', 'Starts the n-second countdown until a player is respawned')
		
	es.msg("delayed_respawn has been restarted, it will function again next round")

def player_activate(event_var):
	if event_var['es_steamid'] not in respawn_status:
		respawn_status[event_var['es_steamid']] = 0

def disable_respawn():
	global respawn_enabled
	respawn_enabled = 0
	es.msg('#green', 'Respawn is now disabled for the rest of this round')
		
def start_countdown():
	userid = es.getcmduserid()
	player = playerlib.getPlayer(userid)

	if respawn_enabled == 1:	
		if (player.isdead and player.teamid > 1):
			if respawn_status[player.steamid] < limit:
				es.tell(userid, '#multi', '#lightgreenYou have invoked respawn: you have #green%i #lightgreenuse(s) left this round, you will respawn in #green%i #lightgreenseconds' % ((limit - respawn_status[player.steamid]), n))
				gamethread.delayedname(n, 'spawn_%s'%player.steamid, do_respawn, userid)
			else:
				es.tell(userid, 'You cannot respawn any more times this round')
		else:
			es.tell(userid, 'You must be dead or on a valid team to respawn!')
	else:
		es.tell(userid, 'Respawn will be enabled at the start of next round for %i seconds' % t)

def do_respawn(target):
	player = playerlib.getPlayer(target)
	respawn_status[player.steamid] += 1

	#check to make sure they didn't switch to spec
	if (player.isdead and player.teamid > 1):
		es.msg('#green', 'Player %s has been respawned' % player.name)
		es.setplayerprop(target, "CCSPlayer.m_iPlayerState", 0)
		es.setplayerprop(target, "CCSPlayer.baseclass.m_lifeState", 512)
		es.server.queuecmd('es_spawnplayer %s' % target)
	else:
		es.tell(target, 'ERROR: You cannot respawn as a spectator')

def player_death(event_var): #and if auto_respawn global == 1 to do auto respawns...
	if respawn_status[event_var['es_steamid']] < limit and respawn_enabled == 1:
		gamethread.delayedname(n, 'autospawn_%s'%event_var['es_steamid'], do_respawn, event_var['userid'])
		es.tell(event_var['userid'], '#multi', "#lightgreenAuto-respawn activated (#green%i #lightgreensecond delay)" % n)

def round_end(event_var):
	global respawn_enabled
	respawn_enabled = 0
	gamethread.cancelDelayed('disable_countdown')
	
	for userid in es.getUseridList():
		gamethread.cancelDelayed('spawn_%s'%es.getplayersteamid(userid))
		gamethread.cancelDelayed('autospawn_%s'%es.getplayersteamid(userid))

def round_start(event_var):
	global respawn_enabled
	respawn_enabled = 1
	
	gamethread.cancelDelayed('disable_countdown')
	
	es.msg('#multi', '#darkgreenAuto-respawn is enabled for #green%i #darkgreenseconds, limit #green%i #darkgreenrespawn per round' % (t, limit))
	
	for userid in es.getUseridList():
		respawn_status[es.getplayersteamid(userid)] = 0
		
	gamethread.delayedname(t + es.ServerVar('mp_freezetime'), 'disable_countdown', disable_respawn)

def player_disconnect(event_var):
	gamethread.cancelDelayed('autospawn_%s'%es.getplayersteamid(event_var['userid']))
	
def es_map_start(event_var):
	respawn_status.clear()
	gamethread.cancelDelayed('disable_countdown')

def unload():
	es.unregsaycmd('!respawn')
